// Simple Example for component dOPCGUI
// This example is based on Matrikon Simulation OPC Server
// You can download the server for free at: http://www.matrikon.com
// But it's a trivial matter to change to another OPC Server.
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  {$IFDEF VER140}
  variants,                                                  // Delphi 6
  {$ENDIF}
  dOPCGUI, dOPC,
  StdCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    OPCServer: TdOPCServer;
    OPCGUI: TdOPCGUI;
    procedure FormShow(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
// if you want default property and default work at designtime
// please modify the unit dGUIRegControls.pas and compile the dOPC package
procedure AddValToListBox(Control: tControl; const OPCValue: OleVariant);
var
 i     : integer;
 Count : integer;
begin
  TListbox(Control).Items.Clear;                  // empty Listbox
  if not VarIsEmpty(OPCValue) then
    if VarIsArray(OPCValue) then                  // if Value is an Array
    begin
      Count := VarArrayHighBound(OPCValue, 1);    // get Count of Values
      for i := 0 to Count do                      // for all Values
        TListbox(Control).Items.Add(OPCValue[i]); // add to Listbox
    end
    else                                          // "normal" Value
     TListbox(Control).Items.Add(OPCValue);       // add to Listbox
end;


procedure TForm1.FormShow(Sender: TObject);
var
  G    : TdOPCGroup;
  Item : TdOPCItem;
begin
  RegisterGUIControl(TListBox,'items',AddValToListBox);  // register new work procedure for TListbox
  OPCServer.Servername := 'Matrikon.OPC.Simulation';     // select your OPC Server
  G := OPCServer.OPCGroups.Add('test');                  // make a new group
  Item := G.OPCItems.AddItem('Random.ArrayOfString');    // add new Array Item
  OPCGUI.Additem(Item,Listbox1,'items');                 // Show Values in Listbox
  OPCServer.Active := true;                              // let's go
end;

end.
